#include <pic.h>
#include "LCD_Defs.h"			// LCDXʸ`W٩wq & ƪΩwq

void Initialize_LCD(void) 
{
								// Select the Segment for the LCD drive; 1 for LCD Segment, 0 for I/O Function
	LCDSE0 = 0b10111001 ;		// Seg 0,3,4,5,7
	LCDSE1 = 0b10000000 ;		// Seg 15
    LCDSE2 = 0b11111111 ;		// Seg 23 ~16

	Clear_LCD( );

	LCDCON = 0x8F ;				// LCD Driver Enable, Clock Source: Internal 31KHz, 1/4 COM<3:0> with 1/3 Bias
								// COM0: pin 14, COM1: pin 15, COM2: pin 214, COM3: pin 38

	LCDPS = 0x00 ;				// WAVEFORM TYPE A, LCD MODULE IS ACTIVE
								// PRESCALER IS 1:1,  BIAS IS 0 (CAN BE STATIC OR 1/3)
								
	LCDREF = 0xC0 ;				//Enable Internal Contrast, use the internal Bias Voltage.

	LCDCST = 0x00 ;				// Set Maximum contrast with b000

	LCDRL = 0xc7 ;				// Hi-Power Mode, "A" Power Mode for 7 clocks


}

void Clear_LCD (void)
{
	LCDDATA0 = 0 ;				// Clear all of the LCD pixel. 
	LCDDATA1 = 0 ;
	LCDDATA2 = 0 ;
	LCDDATA3 = 0 ;
	LCDDATA4 = 0 ;
	LCDDATA5 = 0 ;
	LCDDATA6 = 0 ;
	LCDDATA7 = 0 ;
	LCDDATA8 = 0 ;
	LCDDATA9 = 0 ;
	LCDDATA10 = 0 ;
	LCDDATA11 = 0 ;
}

void BlankDigit1(void)
{SEG_1A = 0 ; SEG_1B = 0 ; SEG_1C = 0 ; SEG_1D = 0 ; SEG_1E = 0 ; SEG_1F = 0 ; SEG_1G = 0 ;}

void BlankDigit2(void)
{SEG_2A = 0 ; SEG_2B = 0 ; SEG_2C = 0 ; SEG_2D = 0 ; SEG_2E = 0 ; SEG_2F = 0 ; SEG_2G = 0 ;}

void BlankDigit3(void)
{SEG_3A = 0 ; SEG_3B = 0 ; SEG_3C = 0 ; SEG_3D = 0 ; SEG_3E = 0 ; SEG_3F = 0 ; SEG_3G = 0 ;}

void BlankDigit4(void)
{SEG_4A = 0 ; SEG_4B = 0 ; SEG_4C = 0 ; SEG_4D = 0 ; SEG_4E = 0 ; SEG_4F = 0 ; SEG_4G = 0 ;}

void BlankDigit5(void)
{SEG_5A = 0 ; SEG_5B = 0 ; SEG_5C = 0 ; SEG_5D = 0 ; SEG_5E = 0 ; SEG_5F = 0 ; SEG_5G = 0 ;}


void DisplayDigit3(int	Show_Number)
{
	
  switch(Show_Number)
	{
	
		case 0:
				SEG_3A = 1 ; SEG_3B = 1 ; SEG_3C = 1 ; SEG_3D = 1 ; SEG_3E = 1 ; SEG_3F = 1 ; SEG_3G = 0 ;
				break ;
		case 1:
				SEG_3A = 0 ; SEG_3B = 1 ; SEG_3C = 1 ; SEG_3D = 0 ; SEG_3E = 0 ; SEG_3F = 0 ; SEG_3G = 0 ;
				break ;
		case 2:
				SEG_3A = 1 ; SEG_3B = 1 ; SEG_3C = 0 ; SEG_3D = 1 ; SEG_3E = 1 ; SEG_3F = 0 ; SEG_3G = 1 ;
				break ;
		case 3:
				SEG_3A = 1 ; SEG_3B = 1 ; SEG_3C = 1 ; SEG_3D = 1 ; SEG_3E = 0 ; SEG_3F = 0 ; SEG_3G = 1 ;
				break ;
		case 4:
				SEG_3A = 0 ; SEG_3B = 1 ; SEG_3C = 1 ; SEG_3D = 0 ; SEG_3E = 0 ; SEG_3F = 1 ; SEG_3G = 1 ;
				break ;
		case 5:
				SEG_3A = 1 ; SEG_3B = 0 ; SEG_3C = 1 ; SEG_3D = 1 ; SEG_3E = 0 ; SEG_3F = 1 ; SEG_3G = 1 ;
				break ;
		case 6:
				SEG_3A = 1 ; SEG_3B = 0 ; SEG_3C = 1 ; SEG_3D = 1 ; SEG_3E = 1 ; SEG_3F = 1 ; SEG_3G = 1 ;
				break ;
		case 7:
				SEG_3A = 1 ; SEG_3B = 1 ; SEG_3C = 1 ; SEG_3D = 0 ; SEG_3E = 0 ; SEG_3F = 0 ; SEG_3G = 0 ;
				break ;
		case 8:
				SEG_3A = 1 ; SEG_3B = 1 ; SEG_3C = 1 ; SEG_3D = 1 ; SEG_3E = 1 ; SEG_3F = 1 ; SEG_3G = 1 ;
				break ;
		case 9:
				SEG_3A = 1 ; SEG_3B = 1 ; SEG_3C = 1 ; SEG_3D = 1 ; SEG_3E = 0 ; SEG_3F = 1 ; SEG_3G = 1 ;
				break ;
		case 10 :		//	A
				SEG_3A = 1 ; SEG_3B = 1 ; SEG_3C = 1 ; SEG_3D = 0 ; SEG_3E = 1 ; SEG_3F = 1 ; SEG_3G = 1 ;
				break ;
		case 11 :		// b
				SEG_3A = 0 ; SEG_3B = 0 ; SEG_3C = 1 ; SEG_3D = 1 ; SEG_3E = 1 ; SEG_3F = 1 ; SEG_3G = 1 ;
				break ;
		case 12 : 		// c
				SEG_3A = 1 ; SEG_3B = 0 ; SEG_3C = 0 ; SEG_3D = 1 ; SEG_3E = 1 ; SEG_3F = 1 ; SEG_3G = 0 ;	
				break ;
		case 13 :		// d
				SEG_3A = 0 ; SEG_3B = 1 ; SEG_3C = 1 ; SEG_3D = 1 ; SEG_3E = 1 ; SEG_3F = 0 ; SEG_3G = 1 ;
				break ;
		case 14 :		// e
				SEG_3A = 1 ; SEG_3B = 0 ; SEG_3C = 0 ; SEG_3D = 1 ; SEG_3E = 1 ; SEG_3F = 1 ; SEG_3G = 1 ;
				break ;
		case 15 :		// f 
				SEG_3A = 1 ; SEG_3B = 0 ; SEG_3C = 0 ; SEG_3D = 0 ; SEG_3E = 1 ; SEG_3F = 1 ; SEG_3G = 1 ;
				break ;
		default :
				break ;

	}	
	
}

void DisplayDigit2(int	Show_Number)
{
	
  switch(Show_Number)
	{
	
		case 0:
				SEG_2A = 1 ; SEG_2B = 1 ; SEG_2C = 1 ; SEG_2D = 1 ; SEG_2E = 1 ; SEG_2F = 1 ; SEG_2G = 0 ;
				break ;
		case 1:
				SEG_2A = 0 ; SEG_2B = 1 ; SEG_2C = 1 ; SEG_2D = 0 ; SEG_2E = 0 ; SEG_2F = 0 ; SEG_2G = 0 ;
				break ;
		case 2:
				SEG_2A = 1 ; SEG_2B = 1 ; SEG_2C = 0 ; SEG_2D = 1 ; SEG_2E = 1 ; SEG_2F = 0 ; SEG_2G = 1 ;
				break ;
		case 3:
				SEG_2A = 1 ; SEG_2B = 1 ; SEG_2C = 1 ; SEG_2D = 1 ; SEG_2E = 0 ; SEG_2F = 0 ; SEG_2G = 1 ;
				break ;
		case 4:
				SEG_2A = 0 ; SEG_2B = 1 ; SEG_2C = 1 ; SEG_2D = 0 ; SEG_2E = 0 ; SEG_2F = 1 ; SEG_2G = 1 ;
				break ;
		case 5:
				SEG_2A = 1 ; SEG_2B = 0 ; SEG_2C = 1 ; SEG_2D = 1 ; SEG_2E = 0 ; SEG_2F = 1 ; SEG_2G = 1 ;
				break ;
		case 6:
				SEG_2A = 1 ; SEG_2B = 0 ; SEG_2C = 1 ; SEG_2D = 1 ; SEG_2E = 1 ; SEG_2F = 1 ; SEG_2G = 1 ;
				break ;
		case 7:
				SEG_2A = 1 ; SEG_2B = 1 ; SEG_2C = 1 ; SEG_2D = 0 ; SEG_2E = 0 ; SEG_2F = 0 ; SEG_2G = 0 ;
				break ;
		case 8:
				SEG_2A = 1 ; SEG_2B = 1 ; SEG_2C = 1 ; SEG_2D = 1 ; SEG_2E = 1 ; SEG_2F = 1 ; SEG_2G = 1 ;
				break ;
		case 9:
				SEG_2A = 1 ; SEG_2B = 1 ; SEG_2C = 1 ; SEG_2D = 1 ; SEG_2E = 0 ; SEG_2F = 1 ; SEG_2G = 1 ;
				break ;
		case 10 :		//	A
				SEG_2A = 1 ; SEG_2B = 1 ; SEG_2C = 1 ; SEG_2D = 0 ; SEG_2E = 1 ; SEG_2F = 1 ; SEG_2G = 1 ;
				break ;
		case 11 :		// b
				SEG_2A = 0 ; SEG_2B = 0 ; SEG_2C = 1 ; SEG_2D = 1 ; SEG_2E = 1 ; SEG_2F = 1 ; SEG_2G = 1 ;
				break ;
		case 12 : 		// c
				SEG_2A = 1 ; SEG_2B = 0 ; SEG_2C = 0 ; SEG_2D = 1 ; SEG_2E = 1 ; SEG_2F = 1 ; SEG_2G = 0 ;	
				break ;
		case 13 :		// d
				SEG_2A = 0 ; SEG_2B = 1 ; SEG_2C = 1 ; SEG_2D = 1 ; SEG_2E = 1 ; SEG_2F = 0 ; SEG_2G = 1 ;
				break ;
		case 14 :		// e
				SEG_2A = 1 ; SEG_2B = 0 ; SEG_2C = 0 ; SEG_2D = 1 ; SEG_2E = 1 ; SEG_2F = 1 ; SEG_2G = 1 ;
				break ;
		case 15 :		// f 
				SEG_2A = 1 ; SEG_2B = 0 ; SEG_2C = 0 ; SEG_2D = 0 ; SEG_2E = 1 ; SEG_2F = 1 ; SEG_2G = 1 ;
				break ;
		default :
				break ;

	}	
	
}

void DisplayDigit1(int	Show_Number)
{
	
  switch(Show_Number)
	{
	
		case 0:
				SEG_1A = 1 ; SEG_1B = 1 ; SEG_1C = 1 ; SEG_1D = 1 ; SEG_1E = 1 ; SEG_1F = 1 ; SEG_1G = 0 ;
				break ;
		case 1:
				SEG_1A = 0 ; SEG_1B = 1 ; SEG_1C = 1 ; SEG_1D = 0 ; SEG_1E = 0 ; SEG_1F = 0 ; SEG_1G = 0 ;
				break ;
		case 2:
				SEG_1A = 1 ; SEG_1B = 1 ; SEG_1C = 0 ; SEG_1D = 1 ; SEG_1E = 1 ; SEG_1F = 0 ; SEG_1G = 1 ;
				break ;
		case 3:
				SEG_1A = 1 ; SEG_1B = 1 ; SEG_1C = 1 ; SEG_1D = 1 ; SEG_1E = 0 ; SEG_1F = 0 ; SEG_1G = 1 ;
				break ;
		case 4:
				SEG_1A = 0 ; SEG_1B = 1 ; SEG_1C = 1 ; SEG_1D = 0 ; SEG_1E = 0 ; SEG_1F = 1 ; SEG_1G = 1 ;
				break ;
		case 5:
				SEG_1A = 1 ; SEG_1B = 0 ; SEG_1C = 1 ; SEG_1D = 1 ; SEG_1E = 0 ; SEG_1F = 1 ; SEG_1G = 1 ;
				break ;
		case 6:
				SEG_1A = 1 ; SEG_1B = 0 ; SEG_1C = 1 ; SEG_1D = 1 ; SEG_1E = 1 ; SEG_1F = 1 ; SEG_1G = 1 ;
				break ;
		case 7:
				SEG_1A = 1 ; SEG_1B = 1 ; SEG_1C = 1 ; SEG_1D = 0 ; SEG_1E = 0 ; SEG_1F = 0 ; SEG_1G = 0 ;
				break ;
		case 8:
				SEG_1A = 1 ; SEG_1B = 1 ; SEG_1C = 1 ; SEG_1D = 1 ; SEG_1E = 1 ; SEG_1F = 1 ; SEG_1G = 1 ;
				break ;
		case 9:
				SEG_1A = 1 ; SEG_1B = 1 ; SEG_1C = 1 ; SEG_1D = 1 ; SEG_1E = 0 ; SEG_1F = 1 ; SEG_1G = 1 ;
				break ;
		case 10 :		//	A
				SEG_1A = 1 ; SEG_1B = 1 ; SEG_1C = 1 ; SEG_1D = 0 ; SEG_1E = 1 ; SEG_1F = 1 ; SEG_1G = 1 ;
				break ;
		case 11 :		// b
				SEG_1A = 0 ; SEG_1B = 0 ; SEG_1C = 1 ; SEG_1D = 1 ; SEG_1E = 1 ; SEG_1F = 1 ; SEG_1G = 1 ;
				break ;
		case 12 : 		// c
				SEG_1A = 1 ; SEG_1B = 0 ; SEG_1C = 0 ; SEG_1D = 1 ; SEG_1E = 1 ; SEG_1F = 1 ; SEG_1G = 0 ;	
				break ;
		case 13 :		// d
				SEG_1A = 0 ; SEG_1B = 1 ; SEG_1C = 1 ; SEG_1D = 1 ; SEG_1E = 1 ; SEG_1F = 0 ; SEG_1G = 1 ;
				break ;
		case 14 :		// e
				SEG_1A = 1 ; SEG_1B = 0 ; SEG_1C = 0 ; SEG_1D = 1 ; SEG_1E = 1 ; SEG_1F = 1 ; SEG_1G = 1 ;
				break ;
		case 15 :		// f 
				SEG_1A = 1 ; SEG_1B = 0 ; SEG_1C = 0 ; SEG_1D = 0 ; SEG_1E = 1 ; SEG_1F = 1 ; SEG_1G = 1 ;
				break ;
		default :
				break ;

	}	
	
}

void DisplayDigit4(int	Show_Number)
{
	
  switch(Show_Number)
	{
	
		case 0:
				SEG_4A = 1 ; SEG_4B = 1 ; SEG_4C = 1 ; SEG_4D = 1 ; SEG_4E = 1 ; SEG_4F = 1 ; SEG_4G = 0 ;
				break ;
		case 1:
				SEG_4A = 0 ; SEG_4B = 1 ; SEG_4C = 1 ; SEG_4D = 0 ; SEG_4E = 0 ; SEG_4F = 0 ; SEG_4G = 0 ;
				break ;
		case 2:
				SEG_4A = 1 ; SEG_4B = 1 ; SEG_4C = 0 ; SEG_4D = 1 ; SEG_4E = 1 ; SEG_4F = 0 ; SEG_4G = 1 ;
				break ;
		case 3:
				SEG_4A = 1 ; SEG_4B = 1 ; SEG_4C = 1 ; SEG_4D = 1 ; SEG_4E = 0 ; SEG_4F = 0 ; SEG_4G = 1 ;
				break ;
		case 4:
				SEG_4A = 0 ; SEG_4B = 1 ; SEG_4C = 1 ; SEG_4D = 0 ; SEG_4E = 0 ; SEG_4F = 1 ; SEG_4G = 1 ;
				break ;
		case 5:
				SEG_4A = 1 ; SEG_4B = 0 ; SEG_4C = 1 ; SEG_4D = 1 ; SEG_4E = 0 ; SEG_4F = 1 ; SEG_4G = 1 ;
				break ;
		case 6:
				SEG_4A = 1 ; SEG_4B = 0 ; SEG_4C = 1 ; SEG_4D = 1 ; SEG_4E = 1 ; SEG_4F = 1 ; SEG_4G = 1 ;
				break ;
		case 7:
				SEG_4A = 1 ; SEG_4B = 1 ; SEG_4C = 1 ; SEG_4D = 0 ; SEG_4E = 0 ; SEG_4F = 0 ; SEG_4G = 0 ;
				break ;
		case 8:
				SEG_4A = 1 ; SEG_4B = 1 ; SEG_4C = 1 ; SEG_4D = 1 ; SEG_4E = 1 ; SEG_4F = 1 ; SEG_4G = 1 ;
				break ;
		case 9:
				SEG_4A = 1 ; SEG_4B = 1 ; SEG_4C = 1 ; SEG_4D = 1 ; SEG_4E = 0 ; SEG_4F = 1 ; SEG_4G = 1 ;
				break ;
		case 10 :		//	A
				SEG_4A = 1 ; SEG_4B = 1 ; SEG_4C = 1 ; SEG_4D = 0 ; SEG_4E = 1 ; SEG_4F = 1 ; SEG_4G = 1 ;
				break ;
		case 11 :		// b
				SEG_4A = 0 ; SEG_4B = 0 ; SEG_4C = 1 ; SEG_4D = 1 ; SEG_4E = 1 ; SEG_4F = 1 ; SEG_4G = 1 ;
				break ;
		case 12 : 		// c
				SEG_4A = 1 ; SEG_4B = 0 ; SEG_4C = 0 ; SEG_4D = 1 ; SEG_4E = 1 ; SEG_4F = 1 ; SEG_4G = 0 ;	
				break ;
		case 13 :		// d
				SEG_4A = 0 ; SEG_4B = 1 ; SEG_4C = 1 ; SEG_4D = 1 ; SEG_4E = 1 ; SEG_4F = 0 ; SEG_4G = 1 ;
				break ;
		case 14 :		// e
				SEG_4A = 1 ; SEG_4B = 0 ; SEG_4C = 0 ; SEG_4D = 1 ; SEG_4E = 1 ; SEG_4F = 1 ; SEG_4G = 1 ;
				break ;
		case 15 :		// f 
				SEG_4A = 1 ; SEG_4B = 0 ; SEG_4C = 0 ; SEG_4D = 0 ; SEG_4E = 1 ; SEG_4F = 1 ; SEG_4G = 1 ;
				break ;
		default :
				break ;

	}	
	
}

void DisplayDigit5(int	Show_Number)
{
	
  switch(Show_Number)
	{
	
		case 0:
				SEG_5A = 1 ; SEG_5B = 1 ; SEG_5C = 1 ; SEG_5D = 1 ; SEG_5E = 1 ; SEG_5F = 1 ; SEG_5G = 0 ;
				break ;
		case 1:
				SEG_5A = 0 ; SEG_5B = 1 ; SEG_5C = 1 ; SEG_5D = 0 ; SEG_5E = 0 ; SEG_5F = 0 ; SEG_5G = 0 ;
				break ;
		case 2:
				SEG_5A = 1 ; SEG_5B = 1 ; SEG_5C = 0 ; SEG_5D = 1 ; SEG_5E = 1 ; SEG_5F = 0 ; SEG_5G = 1 ;
				break ;
		case 3:
				SEG_5A = 1 ; SEG_5B = 1 ; SEG_5C = 1 ; SEG_5D = 1 ; SEG_5E = 0 ; SEG_5F = 0 ; SEG_5G = 1 ;
				break ;
		case 4:
				SEG_5A = 0 ; SEG_5B = 1 ; SEG_5C = 1 ; SEG_5D = 0 ; SEG_5E = 0 ; SEG_5F = 1 ; SEG_5G = 1 ;
				break ;
		case 5:
				SEG_5A = 1 ; SEG_5B = 0 ; SEG_5C = 1 ; SEG_5D = 1 ; SEG_5E = 0 ; SEG_5F = 1 ; SEG_5G = 1 ;
				break ;
		case 6:
				SEG_5A = 1 ; SEG_5B = 0 ; SEG_5C = 1 ; SEG_5D = 1 ; SEG_5E = 1 ; SEG_5F = 1 ; SEG_5G = 1 ;
				break ;
		case 7:
				SEG_5A = 1 ; SEG_5B = 1 ; SEG_5C = 1 ; SEG_5D = 0 ; SEG_5E = 0 ; SEG_5F = 0 ; SEG_5G = 0 ;
				break ;
		case 8:
				SEG_5A = 1 ; SEG_5B = 1 ; SEG_5C = 1 ; SEG_5D = 1 ; SEG_5E = 1 ; SEG_5F = 1 ; SEG_5G = 1 ;
				break ;
		case 9:
				SEG_5A = 1 ; SEG_5B = 1 ; SEG_5C = 1 ; SEG_5D = 1 ; SEG_5E = 0 ; SEG_5F = 1 ; SEG_5G = 1 ;
				break ;
		case 10 :		//	A
				SEG_5A = 1 ; SEG_5B = 1 ; SEG_5C = 1 ; SEG_5D = 0 ; SEG_5E = 1 ; SEG_5F = 1 ; SEG_5G = 1 ;
				break ;
		case 11 :		// b
				SEG_5A = 0 ; SEG_5B = 0 ; SEG_5C = 1 ; SEG_5D = 1 ; SEG_5E = 1 ; SEG_5F = 1 ; SEG_5G = 1 ;
				break ;
		case 12 : 		// c
				SEG_5A = 1 ; SEG_5B = 0 ; SEG_5C = 0 ; SEG_5D = 1 ; SEG_5E = 1 ; SEG_5F = 1 ; SEG_5G = 0 ;	
				break ;
		case 13 :		// d
				SEG_5A = 0 ; SEG_5B = 1 ; SEG_5C = 1 ; SEG_5D = 1 ; SEG_5E = 1 ; SEG_5F = 0 ; SEG_5G = 1 ;
				break ;
		case 14 :		// e
				SEG_5A = 1 ; SEG_5B = 0 ; SEG_5C = 0 ; SEG_5D = 1 ; SEG_5E = 1 ; SEG_5F = 1 ; SEG_5G = 1 ;
				break ;
		case 15 :		// f 
				SEG_5A = 1 ; SEG_5B = 0 ; SEG_5C = 0 ; SEG_5D = 0 ; SEG_5E = 1 ; SEG_5F = 1 ; SEG_5G = 1 ;
				break ;
		default :
				break ;

	}	
	
}		 