#include <pic.h>
#include "LCD_Defs.h"
#include "Main.h"

__CONFIG ( FOSC_INTOSC & WDTE_OFF & PWRTE_OFF & MCLRE_ON & CP_OFF & BOREN_ON & CLKOUTEN_ON
		   & IESO_OFF & FCMEN_OFF); 
__CONFIG ( FCMEN_OFF & VCAPEN_OFF & PLLEN_ON & STVREN_OFF & BORV_25 & LVP_OFF);


extern union
{ 	
	unsigned int Full_Timer ;
	unsigned char Timer_Byte[2] ;
}CSM;  

extern unsigned char CSM_Flag;
extern unsigned int CSM_BUF[16];
extern unsigned char Key_Input;
extern unsigned char CSM_Key;
extern unsigned int CSM_ever_Freq_Temp;

unsigned int CSM_ever_Freq;
unsigned char Disp_Count=0;
unsigned int *CSM_Ptr;
unsigned char i; 

void main(void)
{
		OSCCONbits.IRCF=0B1110;		// 8MHz * 4PLL = 32MHz(Fosc)

		Initialize_CPU() ;
   		Cap_Init();
		Init_Timer4();
		Initialize_LCD() ;
 		GIE=1;				 	

	while(1)
	{
		if (Key_Input==0x01) {  	// S5 UɡALED6 A
				LED6 =!LED6; 
				Key_Input=0;
			}

		if (Key_Input==0x02) {  	// S6 UɡALED7 A
 				LED7 = !LED7; 
				Key_Input=0;
			}

		if (CSM_Key ==1) LED8_On;	// ĲU, BWvC 350KHz IG LED8
		else LED8_Off;


		if (CSM_Flag)
		{
			CSM_Flag=0;
			CSM_Ptr= &CSM_BUF[0];
			CSM_ever_Freq=0;
	
			for (i=0;i<=15;i++)
			{
				CSM_ever_Freq=*CSM_Ptr++ + CSM_ever_Freq;  //CSM Wv 16 
			}
			Disp_Count++;
	
			if (Disp_Count==100)			// 100mS s LCD Wv@
			{
				CSM_ever_Freq= CSM_ever_Freq>>4;   	// [`᪺WvȰH 16A
				CSM_ever_Freq_Temp = CSM_ever_Freq;
	
				SEG_1A = 1 ; SEG_1B = 0 ; SEG_1C = 0 ; SEG_1D = 0 ; SEG_1E = 1 ; SEG_1F = 1 ; SEG_1G = 1 ; //Display "F"
				SEG_2A = 0 ; SEG_2B = 0 ; SEG_2C = 0 ; SEG_2D = 1 ; SEG_2E = 0 ; SEG_2F = 0 ; SEG_2G = 1 ; //Display "="
	
				DisplayDigit3((CSM_ever_Freq/100));			// ܭӦ
				CSM_ever_Freq=CSM_ever_Freq%100;
	
				DisplayDigit4(CSM_ever_Freq/10);			// ܤQ
				CSM_ever_Freq=CSM_ever_Freq%10;
	
				DisplayDigit5(CSM_ever_Freq);				// ܭӦ
				
				Disp_Count=0;
			}
		}
	}
}
	


void Delay_Second(int Delay_Count)
{
	unsigned char i;

	for (i=0;i<= Delay_Count; i++)
	{
		Delay_Long() ;
	}
}


void Delay_Long(void)
{
	int		Delay1 , Delay2 ;

	for ( Delay1 = 0 ; Delay1 < 20000 ; Delay1 ++ ) ;
}

void Initialize_CPU(void)
{

	ANSELA = 0x00 ;			//  
	ANSELB = 0x00 ;
	ANSELD = 0x00 ;
	ADCON1 = 0x50 ;			// Fosc/16

	TRISB4 = 0 ;	// output for COM0
	NOP();
	TRISB5 = 0 ;	// output for COM1
	NOP();
	TRISA2 = 0 ;	// output for COM2
	NOP();
	TRISD0 = 0 ;	// output for COM3
	NOP();
	
	TRISD1 = 1 ; 	// Input for SW5
	NOP();
	TRISD2 = 1 ; 	// Inout for SW6
	NOP();
	TRISC6 = 0 ; 	// Output for LED6
	NOP();
	TRISC7 = 0 ; 	// Output for LED7
	NOP();
	TRISB3 = 0 ; 	// Output for LED8
	NOP();

	LED6_Off;
	NOP();
	LED7_Off;
	NOP();
	LED8_Off;
	NOP();

							// Configure PR2 to 31.2Khz PWM

}

